Modify

Opened 5 years ago

Closed 5 years ago

Last modified 22 months ago

#9207 closed defect (fixed)

txpower may be limited to 20 dBm on Ubiquiti M900 series with regdomain=US

Reported by: vaden@… Owned by: developers
Priority: high Milestone: Barrier Breaker 14.07
Component: base system Version: Trunk
Keywords: txpower Ubiquiti M900 ap cpe Cc: adrian@…, associates@…

Description

OpenWrt revision under study was r26563.

Statements similar to
'iw wlan0 set txpower fixed 300'
were invoked to change the power on the AP; the statement used to measure power at the CPE was:
'iw wlan0 station dump'

For brevity, the data is presented in tabular form vs. transcript form:

Power at AP  Signal Strength
 (mBm)             At CPE 
============================
  300            -103 dBm
  600            -100 dBm
  900             -97 dBm
 1200             -95 dBm
 1500             -92 dBm
 1800             -89 dBm
 2100             -86 dBm
 2400             -86 dBm
 2700             -86 dBm
 2000             -87 dBm

Respectfully submitted/ldv/vaden@…

Attachments (0)

Change History (16)

comment:1 Changed 5 years ago by Nilfred <nilfred@…>

invalid/wontfix: OpenWrt binaries don't allow override regdomain.

comment:2 follow-up: Changed 5 years ago by adrian@…

Hi!

I think that's a bit premature. What's the US regdomain limit for 2.4ghz frequencies? That's what the above is going to be using when calculating these things.

comment:3 in reply to: ↑ 2 Changed 5 years ago by anonymous

Replying to adrian@…:

Hi!

I think that's a bit premature. What's the US regdomain limit for 2.4ghz frequencies? That's what the above is going to be using when calculating these things.

As am I :)

One, out of many answers, right or wrong, is from a stock (read: unmodified) r26563:

cfg80211: Calling CRDA for country: US
cfg80211: Regulatory domain changed to country: US
cfg80211:     (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
cfg80211:     (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2700 mBm)
cfg80211:     (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 1700 mBm)
cfg80211:     (5250000 KHz - 5330000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5490000 KHz - 5600000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5650000 KHz - 5710000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 3000 mBm)

comment:4 Changed 5 years ago by vaden@…

On Mon, Apr 11, 2011 at 11:06 AM, Matt Hardy <matt@ubnt.com> wrote:
>
> Hi Larry, 
>
> Answers inline:
>
> On Mon, Apr 11, 2011 at 11:58 AM, Larry Vaden <vaden@texoma.net> wrote:
>>
>> Are the tx power levels for the M900 set in exactly the same fashion
>> as for the M2 and M5 or is there a difference because of the
>> f-converter?
>
> Yes, they are the same 
>  
>> What is the maximum tx power level for Rocket M900 approved by the FCC
>> when used in conjunction with the Ubiquiti 120 sector for 900 MHz?
>
> 23dBm

comment:5 Changed 5 years ago by vaden@…

The AP seems to get the right answer:

Compat-wireless backport release: compat-wireless-2011-03-30-6-g6a250de
Backport based on wireless-testing.git master-2011-04-06
cfg80211: Calling CRDA to update world regulatory domain
usbcore: registered new interface driver usbfs
usbcore: registered new interface driver hub
usbcore: registered new device driver usb
cfg80211: World regulatory domain updated:
cfg80211:     (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
cfg80211:     (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (2457000 KHz - 2482000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (2474000 KHz - 2494000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
PCI: Setting latency timer of device 0000:00:00.0 to 64
ath: EEPROM regdomain: 0x0
ath: EEPROM indicates default country code should be used
ath: doing EEPROM country->regdmn map search
ath: country maps to regdmn code: 0x3a
ath: Country alpha2 being used: US
ath: Regpair used: 0x3a
ieee80211 phy0: Selected rate control algorithm 'minstrel_ht'
Registered led device: ath9k-phy0
ieee80211 phy0: Atheros AR9280 Rev:2 mem=0xb0000000, irq=72
cfg80211: Calling CRDA for country: US
PPP generic driver version 2.4.2
ip_tables: (C) 2000-2006 Netfilter Core Team
cfg80211: Regulatory domain changed to country: US
cfg80211:     (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
cfg80211:     (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2700 mBm)
cfg80211:     (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 1700 mBm)
cfg80211:     (5250000 KHz - 5330000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5490000 KHz - 5600000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5650000 KHz - 5710000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 3000 mBm)

The CPE, however, may get the correct answer only once and not for recurring trips, unless the execution of cfg80211 is not having an effect on power:

Compat-wireless backport release: compat-wireless-2011-03-30-6-g6a250de
Backport based on wireless-testing.git master-2011-04-06
cfg80211: Calling CRDA to update world regulatory domain
usbcore: registered new interface driver usbfs
usbcore: registered new interface driver hub
usbcore: registered new device driver usb
cfg80211: World regulatory domain updated:
cfg80211:     (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
cfg80211:     (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (2457000 KHz - 2482000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (2474000 KHz - 2494000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
PCI: Setting latency timer of device 0000:00:00.0 to 64
ath: EEPROM regdomain: 0x0
ath: EEPROM indicates default country code should be used
ath: doing EEPROM country->regdmn map search
ath: country maps to regdmn code: 0x3a
ath: Country alpha2 being used: US
ath: Regpair used: 0x3a
ieee80211 phy0: Selected rate control algorithm 'minstrel_ht'
Registered led device: ath9k-phy0
ieee80211 phy0: Atheros AR9280 Rev:2 mem=0xb0000000, irq=72
cfg80211: Calling CRDA for country: US
PPP generic driver version 2.4.2
cfg80211: Regulatory domain changed to country: US
cfg80211:     (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
cfg80211:     (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2700 mBm)
cfg80211:     (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 1700 mBm)
cfg80211:     (5250000 KHz - 5330000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5490000 KHz - 5600000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5650000 KHz - 5710000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 3000 mBm)
ip_tables: (C) 2000-2006 Netfilter Core Team
ehci_hcd: USB 2.0 'Enhanced' Host Controller (EHCI) Driver
nf_conntrack version 0.5.0 (970 buckets, 3880 max)
ohci_hcd: USB 1.1 'Open' Host Controller (OHCI) Driver
ar71xx-ohci ar71xx-ohci: Atheros AR71xx built-in OHCI controller
ar71xx-ohci ar71xx-ohci: new USB bus registered, assigned bus number 1
ar71xx-ohci ar71xx-ohci: irq 3, io mem 0x1b000000
hub 1-0:1.0: USB hub found
hub 1-0:1.0: 1 port detected
wlan0: direct probe to 00:15:6d:4e:f1:46 (try 1/3)
wlan0: direct probe responded
wlan0: authenticate with 00:15:6d:4e:f1:46 (try 1)
wlan0: authenticated
wlan0: associate with 00:15:6d:4e:f1:46 (try 1)
wlan0: RX AssocResp from 00:15:6d:4e:f1:46 (capab=0x1 status=0 aid=1)
wlan0: associated
ar71xx-wdt: enabling watchdog timer
cfg80211: Calling CRDA to update world regulatory domain
cfg80211: World regulatory domain updated:
cfg80211:     (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
cfg80211:     (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (2457000 KHz - 2482000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (2474000 KHz - 2494000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
wlan0: authenticate with 00:15:6d:4e:f1:46 (try 1)
wlan0: authenticated
wlan0: associate with 00:15:6d:4e:f1:46 (try 1)
wlan0: RX ReassocResp from 00:15:6d:4e:f1:46 (capab=0x1 status=0 aid=1)
wlan0: associated
cfg80211: Calling CRDA to update world regulatory domain
cfg80211: World regulatory domain updated:
cfg80211:     (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
cfg80211:     (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (2457000 KHz - 2482000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (2474000 KHz - 2494000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
wlan0: authenticate with 00:15:6d:4e:f1:46 (try 1)
wlan0: authenticated
wlan0: associate with 00:15:6d:4e:f1:46 (try 1)
wlan0: RX ReassocResp from 00:15:6d:4e:f1:46 (capab=0x1 status=0 aid=1)
wlan0: associated
cfg80211: Calling CRDA to update world regulatory domain
cfg80211: World regulatory domain updated:
cfg80211:     (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
cfg80211:     (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (2457000 KHz - 2482000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (2474000 KHz - 2494000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
cfg80211:     (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
wlan0: authenticate with 00:15:6d:4e:f1:46 (try 1)
wlan0: authenticate with 00:15:6d:4e:f1:46 (try 2)
wlan0: authenticated
wlan0: associate with 00:15:6d:4e:f1:46 (try 1)
wlan0: RX ReassocResp from 00:15:6d:4e:f1:46 (capab=0x1 status=0 aid=1)
wlan0: associated

Further, sometimes dmesg contains reason codes for the disconnects, other times it does not. All reason codes observed have been Reason 7.

The goal is to set 'option txpower 23' in /etc/config/wireless to conform to FCC regs when a 120 degree 13 dBi sector is attached to the Rocket M900 AP per email from Matt Hardy at Ubiquiti.

comment:6 Changed 5 years ago by vaden@…

If one reads Matt Hardy's email above and Matt is correct, then the scope of the problem would seem to include the Rocket M2 and the Rocket M5 and the Bullet M2 HP at a minimum in addition to this report which is focused on the M900.

comment:7 Changed 5 years ago by nbd

  • Resolution set to fixed
  • Status changed from new to closed

I disabled the code that causes the bogus regdomain updates based on 802.11d beacon hints for now, until that code is either fixed or rewritten.
Committed in r26662

comment:8 Changed 5 years ago by vaden@…

THANKS for the timely fix.

r26662 has been in production on our smallest rural pop since about an hour after you released the fix.

On a somewhat related matter, do you believe the signal strengths reported or should I open a ticket? I've never seen a radio report signal strengths weaker than rx sensitivities on the data sheet, but you are in a better position in the food chain to know what is going on.)

This is a Bullet M2 HP with MTI 7.5 dBi omni.

root@jv-2400-ap1:~# iw wlan0 station dump | grep -i signal

signal: -96 dBm
signal avg: -95 dBm
signal: -104 dBm
signal avg: -105 dBm
signal: -74 dBm
signal avg: -74 dBm
signal: -84 dBm
signal avg: -83 dBm
signal: -89 dBm
signal avg: -89 dBm
signal: -96 dBm
signal avg: -97 dBm
signal: -83 dBm
signal avg: -83 dBm
signal: -83 dBm
signal avg: -81 dBm
signal: -89 dBm
signal avg: -89 dBm

root@jv-2400-ap1:~#

comment:9 Changed 5 years ago by vaden@…

Reposted for readability/formatting.

root@jv-2400-ap1:~# iw wlan0 station dump | grep -i signal
        signal:         -96 dBm
        signal avg:     -95 dBm
        signal:         -104 dBm
        signal avg:     -105 dBm
        signal:         -74 dBm
        signal avg:     -74 dBm
        signal:         -84 dBm
        signal avg:     -83 dBm
        signal:         -89 dBm
        signal avg:     -89 dBm
        signal:         -96 dBm
        signal avg:     -97 dBm
        signal:         -83 dBm
        signal avg:     -83 dBm
        signal:         -83 dBm
        signal avg:     -81 dBm
        signal:         -89 dBm
        signal avg:     -89 dBm
root@jv-2400-ap1:~#

comment:10 Changed 5 years ago by nbd

I'm pretty sure the signal strength values match what the hardware thinks the signal strength is, but I'm not sure about the interpretation of those values yet.
I'm already looking into that and I don't think opening up a new ticket for that helps.

comment:11 Changed 5 years ago by Tobias Wolf <towolf@…>

About the signal strength issue. These values dropped by at least 20dbm after a recent commit by Felix related to noise floor and signal calculation in ath9k, IIRC.

Either r26494 or r26368. Probably the latter. Before, I got values that kind of matched my clients, afterwards signal went down towards the noise values, which had been -113 and -119 since I started using ath9k earlier this year.

comment:12 Changed 5 years ago by Tobias Wolf <towolf@…>

I meant »in the range of -113 and -119«.

comment:13 Changed 5 years ago by nbd

I think I'll back out the signal strength calculation change because it seems that neither the results with the hardcoded noise floor, nor the changed variant are accurate.

Using the hardcoded value causes less confusion though because it makes the values comparable to other drivers.

comment:14 Changed 5 years ago by vaden@…

In an effort to get an nth opinion, I loaded dd-wrt (licensed) onto the 124.8 device (CPE) and it reports even stranger stuff:

Bit Rate :1 Mb/s  Tx-Power=20 dBm Sensitivity=0/3
Power Management:off
Link Quality=20/94  Signal level=-256 dBm  Noise level=-115 dBm

all counters beyond that line of output of iwconfig are zero (0).

but it won't communicate (as configured, could be cockpit problem) with the OpenWrt AP; neither would AirOS 5.2.1 (as configured, could be cockpit problem).

dd-wrt reports in dmesg

unexpected operating mode 1ic->ic_cwm.cw_width :0, ic->ic_cwm.cw_extoffset: 0

Sorry, cut and paste is not available due to current configuration of 124.8 and learning curve associated with dd-wrt :(

comment:15 Changed 5 years ago by vaden@…

OpenWrt revision under study was bleeding edge, r26761.

Result 1 is atypical, Result 2 is closer to typical.

That said, the ping result is the best I have seen in weeks of testing.

=====Result 1=====
root@hq-0900-ap1:~# iw wlan0 station dump
Station 00:15:6d:9c:16:df (on wlan0)

inactive time: 150 ms
rx bytes: 1392
rx packets: 15
tx bytes: 933
tx packets: 9
tx retries: 16
tx failed: 1
signal: -57 dBm
signal avg: -80 dBm
tx bitrate: 54.0 MBit/s
rx bitrate: 1.0 MBit/s

=====Result 2=====
root@hq-0900-ap1:~# iw wlan0 station dump
Station 00:15:6d:9c:16:df (on wlan0)

inactive time: 7760 ms
rx bytes: 493
rx packets: 5
tx bytes: 80
tx packets: 1
tx retries: 0
tx failed: 0
signal: -85 dBm
signal avg: -80 dBm
tx bitrate: 1.0 MBit/s
rx bitrate: 1.0 MBit/s

On Tue, Apr 26, 2011 at 8:23 AM, Larry Vaden <vaden@…> wrote:

root@cpe-crockett:~# ping -c 21600 -q 209.151.124.2
PING 209.151.124.2 (209.151.124.2): 56 data bytes

--- 209.151.124.2 ping statistics ---
21600 packets transmitted, 18554 packets received, 14% packet loss
round-trip min/avg/max = 1.055/5.778/1018.569 ms
root@cpe-crockett:~#

comment:16 Changed 22 months ago by jow

  • Milestone changed from Attitude Adjustment 12.09 to Barrier Breaker 14.07

Milestone Attitude Adjustment 12.09 deleted

Add Comment

Modify Ticket

Action
as closed .
The resolution will be deleted. Next status will be 'reopened'.
Author


E-mail address and user name can be saved in the Preferences.

 
Note: See TracTickets for help on using tickets.